searchNodes=[{"doc":"","ref":"ucl.html","title":"ucl","type":"module"},{"doc":"","ref":"ucl.html#to_json/1","title":"ucl.to_json/1","type":"function"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"LibUCL is a human-friendly, automation-oriented parser and generator for Universal Configuration Language or UCL . UCL's main benefits are: human readable and editable with comments machine parsable conversion to/from YAML, JSON macro and include-file support lightning-fast parser UCL is a NIF-based binding to the reference implementation LibUCL , and currently requires that library to be pre-installed on your system. Version 1.0 onwards uses dirty schedulers, but does not yield nor time-slice NIF calls, as this would make the code significantly more complex for a function that is unlikely to be run frequently within the BEAM. UCL comes with friendly functions for both Elixir and Erlang, we are all friends here.","ref":"readme.html#ucl-beam-friendly-bindings-for-libucl","title":"README - UCL: BEAM-friendly bindings for libUCL","type":"extras"},{"doc":"Dependencies libucl is obviously a dependency, and the usual UNIX build chain is required. FreeBSD: textproc/libucl devel/rebar3 OSX: brew install libucl Debian: build-essential from base ` erlang - dev erlang - nox ` from erlang - solutions ` rebar3 ` from https : / / rebar3 . org / OpenBSD: erlang-21 elixir from base ` rebar3 ` from https : / / rebar3 . org / On some systems, LibUCL is missing and you'll need to build it. On Debian, there is a conflicting compression library of the same name.","ref":"readme.html#installation-compilation","title":"README - Installation &amp; Compilation","type":"extras"},{"doc":"OpenBSD $ doas pkg_add pkgconf autogen autoconf-archive autoconf-2.69 \\ automake-1.11 libtool $ tar xzf libucl-*.gz $ cd libucl* $ ./autogen.sh $ ./configure $ make $ doas make install Debian $ sudo apt install autoconf libcurl4-openssl-dev automake libtool \\ autoconf-archive pkg-config $ tar xzf libucl-*.gz $ cd libucl* $ ./autogen.sh $ ./configure --prefix=/usr $ make $ sudo make install Installation Via git clone: $ export PATH=$PATH:/usr/local/lib/erlang25/bin:$HOME/.mix $ mix local.rebar $ rebar3 do clean, compile, ct, ex_doc Via hex in the usual fashion: Elixir: add {:ucl, &quot;~&gt; 1.0&quot;} to mix.exs Erlang: add {ucl, &quot;1.0.0&quot;} to rebar.config Compilation should work on all UNIX-like OS out of the box. There is o Windows support planned, but if you can compile libucl on Windows, get in touch. Tests are available as usual via rebar3 ct , and long-running property tests via rebar3 proper . The property tests are effectively fuzzing the NIF by injecting random binary() data and expecting it to return a classic {ok | error, any()} tuple, and take a considerable amount of time (several hours): $ time rebar3 proper ... 3 hours later ... 00% {60000,66000} 10% {54000,60000} 09% {48000,54000} 10% {42000,48000} 10% {36000,42000} 09% {30000,36000} 09% {24000,30000} 09% {18000,24000} 09% {12000,18000} 10% {6000,12000} 9% {0,6000} ===&gt; 1/1 properties passed OK: Passed 500000 test(s). 11005.99 real 11039.08 user 86.36 sys Although UCL is written in Erlang, and uses rebar3 ,it should compile cleanly as a dependency on any BEAM language.","ref":"readme.html#building-libucl-from-source","title":"README - Building LibUCL from source","type":"extras"},{"doc":"iex&gt; UCL . to_json ( &quot;:foo&quot; ) { :error , :ucl_invalid } iex&gt; &quot;foo: true&quot; |&gt; UCL . to_json! |&gt; Jason . decode! %{ &quot;foo&quot; =&gt; true } 1 &gt; ucl : to_json ( &lt;&lt; &quot;foo: true&quot; &gt;&gt; ) . { ok , &lt;&lt; &quot;{\\n \\&quot;foo\\&quot;: true\\n}&quot; &gt;&gt; } The implementation is intended for functional transformation of config data held in memory, and thus a large portion of the LibUCL API has been summarily ignored. If you need something please let us know.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"UCL is heavily infused by nginx configuration as the example of a convenient configuration system. However, UCL is fully compatible with JSON format and is able to parse json files. For example, you can write the same configuration in the following ways: in nginx like: param = value; section { param = value; param1 = value1; flag = true; number = 10k; time = 0.2s; string = &quot;something&quot;; subsection { host = { host = &quot;hostname&quot;; port = 900; } host = { host = &quot;hostname&quot;; port = 901; } } } or in JSON: { &quot;param&quot;: &quot;value&quot;, &quot;param1&quot;: &quot;value1&quot;, &quot;flag&quot;: true, &quot;subsection&quot;: { &quot;host&quot;: [ { &quot;host&quot;: &quot;hostname&quot;, &quot;port&quot;: 900 }, { &quot;host&quot;: &quot;hostname&quot;, &quot;port&quot;: 901 } ] } }","ref":"readme.html#universal-configuration-language-syntax","title":"README - Universal Configuration Language Syntax","type":"extras"},{"doc":"There are various things that make ucl configuration more convenient for editing than strict json: General syntax sugar Braces are not necessary to enclose a top object: it is automatically treated as an object: &quot;key&quot;: &quot;value&quot; is equal to: {&quot;key&quot;: &quot;value&quot;} There is no requirement of quotes for strings and keys, moreover, : may be replaced = or even be skipped for objects: key = value; section { key = value; } is equal to: { &quot;key&quot;: &quot;value&quot;, &quot;section&quot;: { &quot;key&quot;: &quot;value&quot; } } No commas mess: you can safely place a comma or semicolon for the last element in an array or an object: { &quot;key1&quot;: &quot;value&quot;, &quot;key2&quot;: &quot;value&quot;, } Automatic arrays creation Non-unique keys in an object are allowed and are automatically converted to the arrays internally: { &quot;key&quot;: &quot;value1&quot;, &quot;key&quot;: &quot;value2&quot; } is converted to: { &quot;key&quot;: [&quot;value1&quot;, &quot;value2&quot;] } Named keys hierarchy UCL accepts named keys and organize them into objects hierarchy internally. Here is an example of this process: section &quot;blah&quot; { key = value; } section foo { key = value; } is converted to the following object: section { blah { key = value; } foo { key = value; } } Plain definitions may be more complex and contain more than a single level of nested objects: section &quot;blah&quot; &quot;foo&quot; { key = value; } is presented as: section { blah { foo { key = value; } } } Convenient numbers and booleans Numbers can have suffixes to specify standard multipliers: [kKmMgG] - standard 10 base multipliers (so 1k is translated to 1000) [kKmMgG]b - 2 power multipliers (so 1kb is translated to 1024) [s|min|d|w|y] - time multipliers, all time values are translated to float number of seconds, for example 10min is translated to 600.0 and 10ms is translated to 0.01 Hexadecimal integers can be used by 0x prefix, for example key = 0xff . However, floating point values can use decimal base only. Booleans can be specified as true or yes or on and false or no or off . It is still possible to treat numbers and booleans as strings by enclosing them in double quotes.","ref":"readme.html#improvements-to-the-json-notation","title":"README - Improvements to the json notation.","type":"extras"},{"doc":"Comments UCL supports different style of comments: single line: # multiline: /* ... */ Multiline comments may be nested: # Sample single line comment /* some comment /* nested comment */ end of comment */","ref":"readme.html#general-improvements","title":"README - General improvements","type":"extras"},{"doc":"Paul Davis, whose well documented NIF examples made writing this almost cake","ref":"readme.html#thanks","title":"README - Thanks","type":"extras"},{"doc":"BSD 2-Clause License Copyright (c) 2019, SkunkWerks, GmbH All rights reserved. Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met: 1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html","title":"LICENSE","type":"extras"}]